﻿######################################################
#Clear Screen, Generated Form Functions and startup..#
######################################################
CLS
Write-Output "Starting up, please wait.."
#region functions
Function Get-Folder($initialDirectory)

{
    [System.Reflection.Assembly]::LoadWithPartialName("System.windows.forms")

    $foldername = New-Object System.Windows.Forms.FolderBrowserDialog
    $foldername.rootfolder = "MyComputer"

    if($foldername.ShowDialog() -eq "OK")
    {
        $folder += $foldername.SelectedPath
    }
    return $folder
}

function gridClick(){
$selectedRow = $dataGridView1.currentcell.Value
$picturebox1.Image = $image1
$ADUser = (([adsisearcher]"Samaccountname=$selectedRow").findone()).Properties
[byte[]]$imgdata = $ADUser.thumbnailphoto | %{ $_ }
$image=[System.Drawing.Image]::FromStream([System.IO.MemoryStream]$imgdata)
$picturebox1.Image= $image
}

Function Get-FileName($initialDirectory)
{
    [System.Reflection.Assembly]::LoadWithPartialName("System.windows.forms") | Out-Null
	    $OpenFileDialog = New-Object System.Windows.Forms.OpenFileDialog
    $OpenFileDialog.initialDirectory = $initialDirectory
    $OpenFileDialog.filter = "JPG (*.jpg)| *.jpg"
    $OpenFileDialog.ShowDialog() | Out-Null
	$OpenFileDialog.filename
}
function Add-Node { 
        param ( 
            $selectedNode, 
            $name
        ) 
        $newNode = new-object System.Windows.Forms.TreeNode  
        $newNode.Name = $name 
        $newNode.Text = $name 
        $selectedNode.Nodes.Add($newNode) | Out-Null 
        return $newNode 
} 
function Search(){
    $RowIndex = 0
    $ColumnIndex = 0
    $SearchString = $searchtb.Text

    if($SearchString -eq "")
    {
        return
    }

    if($datagridview1.CurrentCell -ne $null)
    {
        $RowIndex = $datagridview1.CurrentCell.RowIndex
        $ColumnIndex = $datagridview1.CurrentCell.ColumnIndex + 1
    }

    $columnCount = $datagridview1.ColumnCount
    $rowCount = $datagridview1.RowCount
    for (;$RowIndex -lt $rowCount; $RowIndex++)
    {
        $Row = $datagridview1.Rows[$RowIndex]

        for(;$ColumnIndex -lt $columnCount; $ColumnIndex++)
        {

            $cell = $Row.Cells[$ColumnIndex]

            if($cell.Value -ne $null -and $cell.Value.ToString().IndexOf($SearchString, [StringComparison]::OrdinalIgnoreCase) -ne -1)
            {
                $datagridview1.CurrentCell =$cell
				$statusBar1.text = "Found " + $SearchString
                return
            }
        }

        $Columnindex = 0
    }

    $datagridview1.CurrentCell = $null
    [void][System.Windows.Forms.MessageBox]::Show("Not Found: " + $SearchString)

}
function Get-NextLevel {
    param (
        $selectedNode,
        $dn
   )
   
    $OUs = Get-ADObject -Filter 'ObjectClass -eq "organizationalUnit" -or ObjectClass -eq "container"' -SearchScope OneLevel -SearchBase $dn

    If ($OUs -eq $null) {
        $node = Add-Node $selectedNode $dn
    } Else {
        $node = Add-Node $selectedNode $dn
        
        $OUs | % {
            Get-NextLevel $node $_.distinguishedName
        }
    }
}
function Build-TreeView { 
    if ($treeNodes)  
    {  
          $ADTreeView.Nodes.remove($treeNodes) 
        $form1.Refresh() 
    } 
    
    $treeNodes = New-Object System.Windows.Forms.TreeNode 
    $treeNodes.text = "Active Directory Hierarchy" 
    $treeNodes.Name = "Active Directory Hierarchy" 
    $treeNodes.Tag = "root" 
    $ADTreeView.Nodes.Add($treeNodes) | Out-Null 
     
    $ADTreeView.add_AfterSelect({ 
        $DomainTextBox.Text = $this.SelectedNode.Name
    }) 
     
    #Generate Module nodes 
    $OUs = Get-NextLevel $treeNodes $strDomainDN
    
    $treeNodes.Expand() 
} 
#endregion functions
function GenerateForm {
################################################
# Created   On: 31/08/2016 15:54               #
# Created By: Jimmy White www.deviousweb.com   #
################################################

#region Import the Assemblies
Import-Module ActiveDirectory
[reflection.assembly]::loadwithpartialname("System.Windows.Forms") | Out-Null
[reflection.assembly]::loadwithpartialname("System.Drawing") | Out-Null
    $objIPProperties = [System.Net.NetworkInformation.IPGlobalProperties]::GetIPGlobalProperties()
    $strDNSDomain = $objIPProperties.DomainName.toLower()
    $strDomainDN = $strDNSDomain.toString().split('.'); foreach ($strVal in $strDomainDN) {$strTemp += "dc=$strVal,"}; $strDomainDN = $strTemp.TrimEnd(",").toLower()
    
#endregion

#region Generated Form Objects
$form1 = New-Object System.Windows.Forms.Form
$checkBox1 = New-Object System.Windows.Forms.CheckBox
$genpicbtn = New-Object System.Windows.Forms.Button
$searchtb = New-Object System.Windows.Forms.TextBox
$searchbtn = New-Object System.Windows.Forms.Button
$showpicbtn = New-Object System.Windows.Forms.Button
$pictureBox1 = New-Object System.Windows.Forms.PictureBox
$dataGridView1 = New-Object System.Windows.Forms.DataGridView
$DomaintextBox = New-Object System.Windows.Forms.TextBox
$statusBar1 = New-Object System.Windows.Forms.StatusBar
$ImportBrowseBtn = New-Object System.Windows.Forms.Button
$textBox1 = New-Object System.Windows.Forms.TextBox
$label2 = New-Object System.Windows.Forms.Label
$PicImportBtn = New-Object System.Windows.Forms.Button
$deletebtn = New-Object System.Windows.Forms.Button
$DeleteAllBtn = New-Object System.Windows.Forms.Button
$ConnectAD_BTN = New-Object System.Windows.Forms.Button
$SaveBtn = New-Object System.Windows.Forms.Button
$SaveAllBtn = New-Object System.Windows.Forms.Button
$GetUsersBtn = New-Object System.Windows.Forms.Button
$label1 = New-Object System.Windows.Forms.Label
$ADTreeView = New-Object System.Windows.Forms.TreeView
$openFileDialog1 = New-Object System.Windows.Forms.OpenFileDialog
$InitialFormWindowState = New-Object System.Windows.Forms.FormWindowState
#endregion Generated Form Objects

################################################
#              Event Script Blocks             #
################################################
#region events
$SaveBtn_OnClick= 
{
############################################
#             Replace a user pic           #
############################################
$inputfile = Get-FileName ""
$inputdata = get-content $inputfile
## need to resize it
	$targetwidth = 96 
	$targetheight = 96

					$OldImage = new-object System.Drawing.Bitmap "$inputfile"
					$OldWidth = $OldImage.Width
					$OldHeight = $OldImage.Height

					if($OldWidth -lt $OldHeight){
						$NewWidth = $targetwidth
						[int]$NewHeight = [Math]::Round(($NewWidth*$OldHeight)/$OldWidth)

						if($NewHeight -gt $targetheight){
							$NewHeight = $targetheight
							[int]$NewWidth = [Math]::Round(($NewHeight*$OldWidth)/$OldHeight)
						}
					}
					else{
						$NewHeight = $targetheight
						[int]$NewWidth = [Math]::Round(($NewHeight*$OldWidth)/$OldHeight)

						if($NewWidth -gt $targetwidth){
							$NewWidth = $targetwidth
							[int]$NewHeight = [Math]::Round(($NewWidth*$OldHeight)/$OldWidth)
						}     
					}
					
					#Resize Working Image
					$NewImage = new-object System.Drawing.Bitmap $NewWidth,$NewHeight
					$Graphics = [System.Drawing.Graphics]::FromImage($NewImage)
					$Graphics.InterpolationMode = [System.Drawing.Drawing2D.InterpolationMode]::HighQualityBicubic
					$Graphics.DrawImage($OldImage, 0, 0, $NewWidth, $NewHeight)

					#Save Working Image
					$ImageFormat = $OldImage.RawFormat
					$OldImage.Dispose()
					$resizedname=$inputfile+"resized.jpg"
					$NewImage.Save("$resizedname",$ImageFormat)
					$NewImage.Dispose()

$form1.cursor="WaitCursor"
$img = [System.Drawing.Image]::Fromfile($resizedname);
$picturebox1.image = $img

$selectedRow = $dataGridView1.currentcell.Value
$statusBar1.text="Replacing Photo, please wait.."
$photo = [byte[]](Get-Content $resizedname -Encoding byte)            
Set-ADUser $selectedRow -Replace @{thumbnailPhoto=$photo}

$statusBar1.text="User "+$selectedRow+" picture has been replaced"
Start-Sleep -s 3
$form1.cursor="Arrow"
$statusBar1.text="Ready.."


}
$searchbtn_OnClick= 
{
############################################
#      Simple search of returned users      #
############################################
Search($searchtb.Text)

}
$showpicbtn_OnClick= 
{
############################################
#     Show Selected Picture(s) from AD     #
############################################
$form1.cursor="WaitCursor"
$selectedRow = $dataGridView1.currentcell.Value
$picturebox1.Image = $image1
$ADUser = (([adsisearcher]"Samaccountname=$selectedRow").findone()).Properties
[byte[]]$imgdata = $ADUser.thumbnailphoto | %{ $_ }
$image=[System.Drawing.Image]::FromStream([System.IO.MemoryStream]$imgdata)
$picturebox1.Image= $image
$statusBar1.text="Showing Picture for user "+$selectedRow
$form1.cursor="Arrow"

}
$deletebtn_OnClick= 
{
CLS
############################################
#    Delete Selected Picture(s) from AD    #
############################################
$form1.cursor="WaitCursor"
$statusBar1.text="Deleting Picture"
$selectedRow = $dataGridView1.currentcell.Value
Set-ADUser $selectedRow -Clear thumbnailphoto
$statusBar1.text="Picture Deleted... Refreshing"
$statusBar1.text = "Getting Users..."
$array = New-Object System.Collections.ArrayList
$baseou=$DomainTextBox.text
#$data = Get-ADUser -SearchBase $baseou -Filter * -Properties thumbnailPhoto | Where-Object {$_.thumbnailphoto -ne $null}| select name, thumbnailphoto | Select-Object 'Name','title', 'displayName';
$data = get-aduser -SearchBase $baseou -filter { objectClass -eq "User" -and Enabled -eq "True" } -Properties SamAccountName,Name,thumbnailPhoto | select SamAccountName,name,thumbnailPhoto

$array.AddRange($data)
$datagridview1.DataSource = $array
$datagridview1.AutoSizeColumnsMode = 16
$form1.autoscroll = $true
$form1.cursor="Arrow"
$statusBar1.text = "Ready..."
}
$genpicbtn_OnClick= 
{
CLS

$inputfile = Get-FileName ""
$inputdata = get-content $inputfile
## need to resize it
	$targetwidth = 96 
	$targetheight = 96

					$OldImage = new-object System.Drawing.Bitmap "$inputfile"
					$OldWidth = $OldImage.Width
					$OldHeight = $OldImage.Height

					if($OldWidth -lt $OldHeight){
						$NewWidth = $targetwidth
						[int]$NewHeight = [Math]::Round(($NewWidth*$OldHeight)/$OldWidth)

						if($NewHeight -gt $targetheight){
							$NewHeight = $targetheight
							[int]$NewWidth = [Math]::Round(($NewHeight*$OldWidth)/$OldHeight)
						}
					}
					else{
						$NewHeight = $targetheight
						[int]$NewWidth = [Math]::Round(($NewHeight*$OldWidth)/$OldHeight)

						if($NewWidth -gt $targetwidth){
							$NewWidth = $targetwidth
							[int]$NewHeight = [Math]::Round(($NewWidth*$OldHeight)/$OldWidth)
						}     
					}
					
					#Resize Working Image
					$NewImage = new-object System.Drawing.Bitmap $NewWidth,$NewHeight
					$Graphics = [System.Drawing.Graphics]::FromImage($NewImage)
					$Graphics.InterpolationMode = [System.Drawing.Drawing2D.InterpolationMode]::HighQualityBicubic
					$Graphics.DrawImage($OldImage, 0, 0, $NewWidth, $NewHeight)

					#Save Working Image
					$ImageFormat = $OldImage.RawFormat
					$OldImage.Dispose()
					$resizedname=$inputfile+"resized.jpg"
					$NewImage.Save("$resizedname",$ImageFormat)
					$NewImage.Dispose()

$form1.cursor="WaitCursor"
$img = [System.Drawing.Image]::Fromfile($resizedname);
$picturebox1.image = $img
$baseou=$DomainTextBox.text
$data = get-aduser -SearchBase $baseou -filter { objectClass -eq "User" -and Enabled -eq "True" } -Properties thumbnailPhoto
$photo = [byte[]](Get-Content $resizedname -Encoding byte) 
foreach ($user in $data) {
$statusBar1.text="Changing picture for "+$user+" to selected generic image"
    Set-Aduser $user -replace @{thumbnailPhoto=$photo}
	}
$form1.cursor="Arrow"
$statusBar1.text="Ready.."
}

$ConnectAD_BTN_OnClick= 
{
Cls
############################################
#     Connect to AD and display in tree    #
############################################
$form1.cursor="WaitCursor"
$statusBar1.text="Fetching AD Records..Please Wait"

Build-TreeView
$form1.cursor="Arrow"
$statusBar1.text="Ready"
}

$PicImportBtn_OnClick= 
{
############################################
#     Import pictures from folder to AD    #
############################################
if ($textbox1.text -eq "") {
#show a message and quit
[System.Windows.Forms.MessageBox]::Show("You need to choose an import folder first...","Alert")
}else{
	#try and import pics
	#Code taken and modified from http://www.theagreeablecow.com/2013/08/automatically-re-size-and-import-photos.html
	$picsource=$textbox1.text
	$form1.cursor="WaitCursor"
	$statusBar1.text="Scanning folder "+$textbox1.text+" for pictures.."
	$targetwidth = 96 
	$targetheight = 96
	$LocalFiles = get-childitem -Path $textbox1.text -filter $TypeFilter | where {!$_.PSIsContainer} | where-object {$_.LastWriteTime -gt $ModifiedAge}
		$LocalCount = $LocalFiles | measure-object
		$LocalFilesCount = $LocalCount.count
		$statusBar1.text="Found "+$LocalFilesCount+" files"
		if ($LocalFilesCount -gt 0){
			foreach ($LocalFile in $LocalFiles){
				$LocalName = [io.path]::GetFileNameWithoutExtension($LocalFile)
				$LocalFilesNames += "$LocalName, "
			}
		}
		$AllFilesCount = $LocalFilesCount
if ($AllFilesCount -gt 0){
$statusBar1.text="Matching and Resizing Pictures"
$AllFiles = get-childitem -Path $picsource -filter $TypeFilter | where {!$_.PSIsContainer}
			
			foreach ($File in $AllFiles){
				#Confirm Photos match Active Directory Username
				$Name = [io.path]::GetFileNameWithoutExtension($File)
				$User = Get-ADUser -Filter {SamAccountName -eq $Name}

				if ($user -ne $null){
					#Export existing photo as a backup
					$Export = Get-ADUser $Name -properties SamAccountName, ThumbnailPhoto
					if ($Export.ThumbnailPhoto -ne $null){
						$FileStamp = "$Name $(get-date -f yyyy-MM-dd-HH-mm-ss).jpg"
						$Export.thumbnailphoto | Set-Content ("$picsource\Exported\$FileStamp") -Encoding byte
					}

					#Determine new dimensions (ensuring to keep proportions)
					$OldImage = new-object System.Drawing.Bitmap "$picsource\$File"
					$OldWidth = $OldImage.Width
					$OldHeight = $OldImage.Height

					if($OldWidth -lt $OldHeight){
						$NewWidth = $targetwidth
						[int]$NewHeight = [Math]::Round(($NewWidth*$OldHeight)/$OldWidth)

						if($NewHeight -gt $targetheight){
							$NewHeight = $targetheight
							[int]$NewWidth = [Math]::Round(($NewHeight*$OldWidth)/$OldHeight)
						}
					}
					else{
						$NewHeight = $targetheight
						[int]$NewWidth = [Math]::Round(($NewHeight*$OldWidth)/$OldHeight)

						if($NewWidth -gt $targetwidth){
							$NewWidth = $targetwidth
							[int]$NewHeight = [Math]::Round(($NewWidth*$OldHeight)/$OldWidth)
						}     
					}
					
					#Resize Working Image
					$NewImage = new-object System.Drawing.Bitmap $NewWidth,$NewHeight
					$Graphics = [System.Drawing.Graphics]::FromImage($NewImage)
					$Graphics.InterpolationMode = [System.Drawing.Drawing2D.InterpolationMode]::HighQualityBicubic
					$Graphics.DrawImage($OldImage, 0, 0, $NewWidth, $NewHeight)

					#Save Working Image
					$ImageFormat = $OldImage.RawFormat
					$OldImage.Dispose()  
					$NewImage.Save("$picsource\$File",$ImageFormat)
					$NewImage.Dispose()

					#Import into AD
					$statusBar1.text="Importing Picture for User "+$name
					$Photo = [byte[]](Get-Content "$picsource\$File" -Encoding byte)
					Set-ADUser $Name -Replace @{thumbnailPhoto=$Photo}

					#Save a copy as Imported
					$FileStamp = "$Name $(get-date -f yyyy-MM-dd-HH-mm-ss).jpg"
					move-item "$picsource\$File" "$picsource\imported\$FileStamp" -force

					#Logging
					$SucessCount = $SucessCount +1
					$SucessFilesNames += "$Name, "
				}
				Else{
					#Logging
					$FailCount = $FailCount +1
					$FailedFilesNames += "$Name, "

					#Delete Working Image
					$FileStamp = "$Name $(get-date -f yyyy-MM-dd-HH-mm-ss).jpg"
					move-item "$picsource\$File" "$picsource\failed\$FileStamp" -force
				}
			}
		}
	}
	$statusBar1.text="Ready.."
	$form1.cursor="Arrow"
	
	}


$DeleteAllBtn_OnClick= 
{
############################################
# Delete all User Tumbnails in selected OU #
############################################
$output=[System.Windows.Forms.MessageBox]::Show("Are you sure you want to delete ALL user pictures in the selected OU ","Alert",4)
if ($OUTPUT -eq "YES" ) 
	{
		$form1.cursor="WaitCursor"
		$statusBar1.text="Deleting Pictures"
		#parse through data grid starting at top
		$r=0
		$c=0
		while ($datagridview1.Rows[$r].Cells[$c].value -ne $null){
			$selectedRow = $dataGridView1.Rows[$r].Cells[$c].value
			$statusBar1.text=$selectedRow+" Deleted in position "+$r
			Set-ADUser $selectedRow -Clear thumbnailphoto
			$r=$r+1
			$statusBar1.text=$selectedRow+" Deleted.."
	}
$statusBar1.text="Pictures Deleted... Refreshing after 10 seconds"
Start-Sleep -s 10
$statusBar1.text = "Getting Users..."
$array = New-Object System.Collections.ArrayList
$baseou=$DomainTextBox.text
#$data = Get-ADUser -SearchBase $baseou -Filter * -Properties thumbnailPhoto | Where-Object {$_.thumbnailphoto -ne $null}| select name, thumbnailphoto | Select-Object 'Name','title', 'displayName';
$data = get-aduser -SearchBase $baseou -filter { objectClass -eq "User" -and Enabled -eq "True" } -Properties SamAccountName,Name,thumbnailPhoto | select SamAccountName,name,thumbnailPhoto

$array.AddRange($data)
$datagridview1.DataSource = $array
$datagridview1.AutoSizeColumnsMode = 16
$form1.autoscroll = $true
$form1.cursor="Arrow"
$statusBar1.text = "Ready..."
}else{$statusBar1.text="Aborted.."}}

$ImportBrowseBtn_OnClick= 
{
###############################################################
#browse for a folder conatining photos we would like to import#
###############################################################
Add-Type -AssemblyName System.Windows.Forms
$FolderBrowser = New-Object System.Windows.Forms.FolderBrowserDialog -Property @{SelectedPath=$ScriptPathTextBox.text}
[Void]$FolderBrowser.ShowDialog()
$FolderBrowser.selectedPath

if ($FolderBrowser.selectedPath -ne $null) {
	$textBox1.text=$FolderBrowser.selectedPath
	}
}

$SaveAllBtn_OnClick= 
{
################################## Save all Photos ##################################
Add-Type -AssemblyName System.Windows.Forms
$FolderBrowser = New-Object System.Windows.Forms.FolderBrowserDialog -Property @{SelectedPath=$ScriptPathTextBox.text}
[Void]$FolderBrowser.ShowDialog()
$FolderBrowser.selectedPath
$form1.cursor="WaitCursor"
if ($FolderBrowser.selectedPath -ne $null) {
	$savelocation=$FolderBrowser.selectedPath
	}
$baseou=$DomainTextBox.text

Set-Location $savelocation
$users = Get-ADUser -Filter * -SearchBase $baseou -Properties thumbnailPhoto  | ? {$_.thumbnailPhoto}

foreach ($user in $users) {
	$statusBar1.text="Saving "+$user.SamAccountName
    $name = $user.SamAccountName + ".jpg"  
    $user.thumbnailPhoto | Set-Content $name -Encoding byte
}  
$statusBar1.text="Completed"
Start-Sleep -s 1
$form1.cursor="Arrow"
$statusBar1.text="Ready.."
}
#####################################################################################
$GetUsersBtn_OnClick= 
{
#TODO: Place custom script here
$form1.cursor="WaitCursor"
$statusBar1.text = "Getting Users..."
$array = New-Object System.Collections.ArrayList
$baseou=$DomainTextBox.text
if ($checkBox1.checked -eq $true){
		#Get-ADUser -Filter * -SearchBase "OU=Staff,DC=nwtraders,DC=msft" -properties thumbnailPhoto | ? {!$_.thumbnailPhoto} | select Name
		$data = @(Get-ADUser -SearchBase $baseou -Filter { objectClass -eq "User" -and Enabled -eq "True" } -Properties SamAccountName,Name,thumbnailPhoto | ? {$_.thumbnailPhoto} | select SamAccountName,name,thumbnailPhoto)
		}else{
		$data = @(get-aduser -SearchBase $baseou -filter { objectClass -eq "User" -and Enabled -eq "True" } -Properties SamAccountName,Name,thumbnailPhoto | select SamAccountName,name,thumbnailPhoto)
		}
		#bug - cant add data to an array of there is only 1 item.. fix..
		
		$array.AddRange($data)
		$datagridview1.DataSource = $array
		$datagridview1.AutoSizeColumnsMode = 16
		$form1.autoscroll = $true
		

		$form1.cursor="Arrow"
		$statusBar1.text = "Ready..."
}

$OnLoadForm_StateCorrection=
{#Correct the initial state of the form to prevent the .Net maximized form issue
	$form1.WindowState = $InitialFormWindowState
}
#endregion events


#region Generated Form Code
$System_Drawing_Size = New-Object System.Drawing.Size
$System_Drawing_Size.Height = 532
$System_Drawing_Size.Width = 872
$form1.ClientSize = $System_Drawing_Size
$form1.DataBindings.DefaultDataSourceUpdateMode = 0
$form1.Name = "form1"
$form1.Text = "UserPic"


$checkBox1.DataBindings.DefaultDataSourceUpdateMode = 0

$System_Drawing_Point = New-Object System.Drawing.Point
$System_Drawing_Point.X = 34
$System_Drawing_Point.Y = 453
$checkBox1.Location = $System_Drawing_Point
$checkBox1.Name = "checkBox1"
$System_Drawing_Size = New-Object System.Drawing.Size
$System_Drawing_Size.Height = 24
$System_Drawing_Size.Width = 203
$checkBox1.Size = $System_Drawing_Size
$checkBox1.TabIndex = 21
$checkBox1.Text = "Only Show Users with Pictures"
$checkBox1.UseVisualStyleBackColor = $True

$form1.Controls.Add($checkBox1)


$genpicbtn.DataBindings.DefaultDataSourceUpdateMode = 0

$System_Drawing_Point = New-Object System.Drawing.Point
$System_Drawing_Point.X = 533
$System_Drawing_Point.Y = 479
$genpicbtn.Location = $System_Drawing_Point
$genpicbtn.Name = "genpicbtn"
$System_Drawing_Size = New-Object System.Drawing.Size
$System_Drawing_Size.Height = 23
$System_Drawing_Size.Width = 103
$genpicbtn.Size = $System_Drawing_Size
$genpicbtn.TabIndex = 20
$genpicbtn.Text = "Generic Pic"
$genpicbtn.UseVisualStyleBackColor = $True
$genpicbtn.add_Click($genpicbtn_OnClick)

$form1.Controls.Add($genpicbtn)

$searchtb.DataBindings.DefaultDataSourceUpdateMode = 0
$System_Drawing_Point = New-Object System.Drawing.Point
$System_Drawing_Point.X = 96
$System_Drawing_Point.Y = 19
$searchtb.Location = $System_Drawing_Point
$searchtb.Name = "searchtb"
$System_Drawing_Size = New-Object System.Drawing.Size
$System_Drawing_Size.Height = 20
$System_Drawing_Size.Width = 175
$searchtb.Size = $System_Drawing_Size
$searchtb.TabIndex = 19

$form1.Controls.Add($searchtb)


$searchbtn.DataBindings.DefaultDataSourceUpdateMode = 0

$System_Drawing_Point = New-Object System.Drawing.Point
$System_Drawing_Point.X = 15
$System_Drawing_Point.Y = 18
$searchbtn.Location = $System_Drawing_Point
$searchbtn.Name = "searchbtn"
$System_Drawing_Size = New-Object System.Drawing.Size
$System_Drawing_Size.Height = 23
$System_Drawing_Size.Width = 75
$searchbtn.Size = $System_Drawing_Size
$searchbtn.TabIndex = 18
$searchbtn.Text = "Search.."
$searchbtn.UseVisualStyleBackColor = $True
$searchbtn.add_Click($searchbtn_OnClick)

$form1.Controls.Add($searchbtn)


$showpicbtn.DataBindings.DefaultDataSourceUpdateMode = 0

$System_Drawing_Point = New-Object System.Drawing.Point
$System_Drawing_Point.X = 535
$System_Drawing_Point.Y = 180
$showpicbtn.Location = $System_Drawing_Point
$showpicbtn.Name = "showpicbtn"
$System_Drawing_Size = New-Object System.Drawing.Size
$System_Drawing_Size.Height = 23
$System_Drawing_Size.Width = 96
$showpicbtn.Size = $System_Drawing_Size
$showpicbtn.TabIndex = 17
$showpicbtn.Text = "Show Picture"
$showpicbtn.UseVisualStyleBackColor = $True
$showpicbtn.add_Click($showpicbtn_OnClick)

$form1.Controls.Add($showpicbtn)


$pictureBox1.BorderStyle = 2
$pictureBox1.DataBindings.DefaultDataSourceUpdateMode = 0



$System_Drawing_Point = New-Object System.Drawing.Point
$System_Drawing_Point.X = 528
$System_Drawing_Point.Y = 45
$pictureBox1.Location = $System_Drawing_Point
$pictureBox1.Name = "pictureBox1"
$System_Drawing_Size = New-Object System.Drawing.Size
$System_Drawing_Size.Height = 122
$System_Drawing_Size.Width = 116
$pictureBox1.Size = $System_Drawing_Size
$pictureBox1.TabIndex = 16
$pictureBox1.TabStop = $False

$form1.Controls.Add($pictureBox1)

$dataGridView1.DataBindings.DefaultDataSourceUpdateMode = 0
$System_Drawing_Point = New-Object System.Drawing.Point
$System_Drawing_Point.X = 12
$System_Drawing_Point.Y = 45
$dataGridView1.Location = $System_Drawing_Point
$dataGridView1.Name = "dataGridView1"
$System_Drawing_Size = New-Object System.Drawing.Size
$System_Drawing_Size.Height = 401
$System_Drawing_Size.Width = 510
$dataGridView1.Size = $System_Drawing_Size
$dataGridView1.TabIndex = 15

$form1.Controls.Add($dataGridView1)

$DomaintextBox.DataBindings.DefaultDataSourceUpdateMode = 0
$System_Drawing_Point = New-Object System.Drawing.Point
$System_Drawing_Point.X = 651
$System_Drawing_Point.Y = 360
$DomaintextBox.Location = $System_Drawing_Point
$DomaintextBox.Name = "DomaintextBox"
$System_Drawing_Size = New-Object System.Drawing.Size
$System_Drawing_Size.Height = 20
$System_Drawing_Size.Width = 209
$DomaintextBox.Size = $System_Drawing_Size
$DomaintextBox.TabIndex = 14

$form1.Controls.Add($DomaintextBox)

$statusBar1.DataBindings.DefaultDataSourceUpdateMode = 0
$System_Drawing_Point = New-Object System.Drawing.Point
$System_Drawing_Point.X = 0
$System_Drawing_Point.Y = 510
$statusBar1.Location = $System_Drawing_Point
$statusBar1.Name = "statusBar1"
$System_Drawing_Size = New-Object System.Drawing.Size
$System_Drawing_Size.Height = 22
$System_Drawing_Size.Width = 872
$statusBar1.Size = $System_Drawing_Size
$statusBar1.TabIndex = 13
$statusBar1.Text = "statusBar1"

$form1.Controls.Add($statusBar1)


$ImportBrowseBtn.DataBindings.DefaultDataSourceUpdateMode = 0

$System_Drawing_Point = New-Object System.Drawing.Point
$System_Drawing_Point.X = 790
$System_Drawing_Point.Y = 477
$ImportBrowseBtn.Location = $System_Drawing_Point
$ImportBrowseBtn.Name = "ImportBrowseBtn"
$System_Drawing_Size = New-Object System.Drawing.Size
$System_Drawing_Size.Height = 23
$System_Drawing_Size.Width = 24
$ImportBrowseBtn.Size = $System_Drawing_Size
$ImportBrowseBtn.TabIndex = 12
$ImportBrowseBtn.Text = "..."
$ImportBrowseBtn.UseVisualStyleBackColor = $True
$ImportBrowseBtn.add_Click($ImportBrowseBtn_OnClick)

$form1.Controls.Add($ImportBrowseBtn)

$textBox1.DataBindings.DefaultDataSourceUpdateMode = 0
$System_Drawing_Point = New-Object System.Drawing.Point
$System_Drawing_Point.X = 642
$System_Drawing_Point.Y = 479
$textBox1.Location = $System_Drawing_Point
$textBox1.Name = "textBox1"
$System_Drawing_Size = New-Object System.Drawing.Size
$System_Drawing_Size.Height = 20
$System_Drawing_Size.Width = 145
$textBox1.Size = $System_Drawing_Size
$textBox1.TabIndex = 11

$form1.Controls.Add($textBox1)

$label2.DataBindings.DefaultDataSourceUpdateMode = 0

$System_Drawing_Point = New-Object System.Drawing.Point
$System_Drawing_Point.X = 674
$System_Drawing_Point.Y = 453
$label2.Location = $System_Drawing_Point
$label2.Name = "label2"
$System_Drawing_Size = New-Object System.Drawing.Size
$System_Drawing_Size.Height = 23
$System_Drawing_Size.Width = 110
$label2.Size = $System_Drawing_Size
$label2.TabIndex = 10
$label2.Text = "Choose Import Folder"

$form1.Controls.Add($label2)


$PicImportBtn.DataBindings.DefaultDataSourceUpdateMode = 0

$System_Drawing_Point = New-Object System.Drawing.Point
$System_Drawing_Point.X = 452
$System_Drawing_Point.Y = 479
$PicImportBtn.Location = $System_Drawing_Point
$PicImportBtn.Name = "PicImportBtn"
$System_Drawing_Size = New-Object System.Drawing.Size
$System_Drawing_Size.Height = 23
$System_Drawing_Size.Width = 75
$PicImportBtn.Size = $System_Drawing_Size
$PicImportBtn.TabIndex = 9
$PicImportBtn.Text = "Pic Import"
$PicImportBtn.UseVisualStyleBackColor = $True
$PicImportBtn.add_Click($PicImportBtn_OnClick)

$form1.Controls.Add($PicImportBtn)


$deletebtn.DataBindings.DefaultDataSourceUpdateMode = 0

$System_Drawing_Point = New-Object System.Drawing.Point
$System_Drawing_Point.X = 371
$System_Drawing_Point.Y = 479
$deletebtn.Location = $System_Drawing_Point
$deletebtn.Name = "OpenPicBtn"
$System_Drawing_Size = New-Object System.Drawing.Size
$System_Drawing_Size.Height = 23
$System_Drawing_Size.Width = 75
$deletebtn.Size = $System_Drawing_Size
$deletebtn.TabIndex = 8
$deletebtn.Text = "Delete"
$deletebtn.UseVisualStyleBackColor = $True
$deletebtn.add_Click($deletebtn_OnClick)

$form1.Controls.Add($deletebtn)


$DeleteAllBtn.DataBindings.DefaultDataSourceUpdateMode = 0

$System_Drawing_Point = New-Object System.Drawing.Point
$System_Drawing_Point.X = 278
$System_Drawing_Point.Y = 479
$DeleteAllBtn.Location = $System_Drawing_Point
$DeleteAllBtn.Name = "DeleteAllBtn"
$System_Drawing_Size = New-Object System.Drawing.Size
$System_Drawing_Size.Height = 23
$System_Drawing_Size.Width = 87
$DeleteAllBtn.Size = $System_Drawing_Size
$DeleteAllBtn.TabIndex = 7
$DeleteAllBtn.Text = "Delete All Pics"
$DeleteAllBtn.UseVisualStyleBackColor = $True
$DeleteAllBtn.add_Click($DeleteAllBtn_OnClick)

$form1.Controls.Add($DeleteAllBtn)


$ConnectAD_BTN.DataBindings.DefaultDataSourceUpdateMode = 0

$System_Drawing_Point = New-Object System.Drawing.Point
$System_Drawing_Point.X = 650
$System_Drawing_Point.Y = 386
$ConnectAD_BTN.Location = $System_Drawing_Point
$ConnectAD_BTN.Name = "ConnectAD_BTN"
$System_Drawing_Size = New-Object System.Drawing.Size
$System_Drawing_Size.Height = 23
$System_Drawing_Size.Width = 75
$ConnectAD_BTN.Size = $System_Drawing_Size
$ConnectAD_BTN.TabIndex = 6
$ConnectAD_BTN.Text = "Connect.."
$ConnectAD_BTN.UseVisualStyleBackColor = $True
$ConnectAD_BTN.add_Click($ConnectAD_BTN_OnClick)

$form1.Controls.Add($ConnectAD_BTN)


$SaveBtn.DataBindings.DefaultDataSourceUpdateMode = 0

$System_Drawing_Point = New-Object System.Drawing.Point
$System_Drawing_Point.X = 196
$System_Drawing_Point.Y = 479
$SaveBtn.Location = $System_Drawing_Point
$SaveBtn.Name = "SaveBtn"
$System_Drawing_Size = New-Object System.Drawing.Size
$System_Drawing_Size.Height = 23
$System_Drawing_Size.Width = 75
$SaveBtn.Size = $System_Drawing_Size
$SaveBtn.TabIndex = 4
$SaveBtn.Text = "Replace"
$SaveBtn.UseVisualStyleBackColor = $True
$SaveBtn.add_Click($SaveBtn_OnClick)

$form1.Controls.Add($SaveBtn)


$SaveAllBtn.DataBindings.DefaultDataSourceUpdateMode = 0

$System_Drawing_Point = New-Object System.Drawing.Point
$System_Drawing_Point.X = 115
$System_Drawing_Point.Y = 479
$SaveAllBtn.Location = $System_Drawing_Point
$SaveAllBtn.Name = "SaveAllBtn"
$System_Drawing_Size = New-Object System.Drawing.Size
$System_Drawing_Size.Height = 23
$System_Drawing_Size.Width = 75
$SaveAllBtn.Size = $System_Drawing_Size
$SaveAllBtn.TabIndex = 3
$SaveAllBtn.Text = "Save All"
$SaveAllBtn.UseVisualStyleBackColor = $True
$SaveAllBtn.add_Click($SaveAllBtn_OnClick)

$form1.Controls.Add($SaveAllBtn)


$GetUsersBtn.DataBindings.DefaultDataSourceUpdateMode = 0

$System_Drawing_Point = New-Object System.Drawing.Point
$System_Drawing_Point.X = 34
$System_Drawing_Point.Y = 479
$GetUsersBtn.Location = $System_Drawing_Point
$GetUsersBtn.Name = "GetUsersBtn"
$System_Drawing_Size = New-Object System.Drawing.Size
$System_Drawing_Size.Height = 23
$System_Drawing_Size.Width = 75
$GetUsersBtn.Size = $System_Drawing_Size
$GetUsersBtn.TabIndex = 2
$GetUsersBtn.Text = "Get Users"
$GetUsersBtn.UseVisualStyleBackColor = $True
$GetUsersBtn.add_Click($GetUsersBtn_OnClick)

$form1.Controls.Add($GetUsersBtn)

$label1.DataBindings.DefaultDataSourceUpdateMode = 0

$System_Drawing_Point = New-Object System.Drawing.Point
$System_Drawing_Point.X = 658
$System_Drawing_Point.Y = 21
$label1.Location = $System_Drawing_Point
$label1.Name = "label1"
$System_Drawing_Size = New-Object System.Drawing.Size
$System_Drawing_Size.Height = 23
$System_Drawing_Size.Width = 100
$label1.Size = $System_Drawing_Size
$label1.TabIndex = 1
$label1.Text = "Select target OU"

$form1.Controls.Add($label1)

$ADTreeView.DataBindings.DefaultDataSourceUpdateMode = 0
$System_Drawing_Point = New-Object System.Drawing.Point
$System_Drawing_Point.X = 650
$System_Drawing_Point.Y = 45
$ADTreeView.Location = $System_Drawing_Point
$ADTreeView.Name = "ADTreeView"
$System_Drawing_Size = New-Object System.Drawing.Size
$System_Drawing_Size.Height = 308
$System_Drawing_Size.Width = 210
$ADTreeView.Size = $System_Drawing_Size
$ADTreeView.TabIndex = 0

$form1.Controls.Add($ADTreeView)

$openFileDialog1.FileName = "openFileDialog1"
$openFileDialog1.ShowHelp = $True

#endregion Generated Form Code
#Save the initial state of the form
$InitialFormWindowState = $form1.WindowState
#Init the OnLoad event to correct the initial state of the form
$form1.add_Load($OnLoadForm_StateCorrection)
#Show the Form
$form1.ShowDialog()| Out-Null
$statusBar1.text = "Ready.."
} #End Function

#Call the Function
GenerateForm
